#         Script : MP3List v1.00 by David Proper (Dr. Nibble [DrN])
#                  Copyright 2002 Radical Computer Systems
#                             All Rights Reserved
#
#       Testing
#      Platforms : Linux 2.4.18   TCL v8.3
#                  Eggdrop v1.6.2
#                  Eggdrop v1.6.6
#            And : SunOS 5.8      TCL v8.3
#                  Eggdrop v1.5.4
#
#    Description : MP3List is geared towards DJs. It lets you compile a
#                  list of your MP3s and allow people to search it online
#                  or DL a complete list. Extra ID3 tag information can 
#                  be requested as well.
#                  Playlist requests can be submitted for DJs who want
#                  to take requests.
#                  (Perl support script requires MP3::Info)
#
#        History : 09/18/2002 - First Release
#
#      Donations : https://www.paypal.com/xclick/business=rainbows%40stx.rr.com
# (If you don't have PayPal and want to donate, EMail me for an address.
#  Will take money or hardware/computer donations)
#  Significant (or even non-significant donations) can be published on a
#  web site if you so choose.
#
#   Future Plans : Fix Bugs. :)
#                 o Add in file request/sending
#
# Author Contact :     Email - DProper@stx.rr.com
#                   Homepage - http://www.chaotix.net/~dproper
#                        IRC - Primary Nick: DrN
#                     UseNet - alt.irc.bots.eggdrop
# Support Channels: #RCS @UnderNet.Org
#                   #RCS @DALnet
#                   #RCS @EFnet
#                   #RCS @GalaxyNet
#                   #RCS @Choatix Addiction
#            Other channels - Check contact page for current list
#
#                Current contact information can be located at:
#                 http://www.chaotix.net/rcs/contact.html
#
# New TCL releases are sent to the following sites as soon as they're released:
#
# FTP Site                   | Directory                     
# ---------------------------+-------------------------------
# ftp.chaotix.net            | /pub/RCS
# ftp.eggheads.org           | Various
# ftp.realmweb.org           | /drn
#
# Chaotix.Net has returned. Web site and mailing list back online
# Main sites are still being repaired. 
#
#   Radical Computer Systems - http://www.chaotix.net/rcs/
# To subscribe to the RCS mailing list: 
#  http://www.chaotix.net/mailman/listinfo/rcs-list
#
#  Feel free to Email me any suggestions/bug reports/etc.
# 
# You are free to use this TCL/script as long as:
#  1) You don't remove or change author credit
#  2) You don't release it in modified form. (Only the original)
# 
# If you have a "too cool" modification, send it to me and it'll be
# included in the official release. (With your credit)
#
# Commands Added:
#  Where     F CMD          F CMD            F CMD           F CMD
#  -------   - ----------   - ------------   - -----------   - ----------
#  Public:   - !mp3list     - !mp3request
#     MSG:   - mp3list      - mp3reuqest
#     DCC:   - mp3requests  - mp3del
#
# Public Matching: N/A
#

set mp3list(ver) "v1.00.00"


# Set this to the maximum nuber of search results to return.
set mp3list(maxsearch) 20

if {[info exists mp3requests]} {unset mp3requests}


set cmdchar_ "!"

# [0/1] Set this to 1 to show the line number in the output
set mp3list(showlinenumber) 1

# Format is:
# path/filename Description
# You can include multiple files to search for.
set mp3list(list) "~/mp3list.dat DJ D's MP3 List"

# FULL path/filename to the human readable MP3 List.
set mp3list(download) "/home/islebot/filesys/text/mp3list.txt"

proc cmdchar { } {
 global cmdchar_
 return $cmdchar_
}


set mp3requests(0) 0

##### GETMP3LIST #######################################################
bind pub - [cmdchar]getmp3list getmp3list
proc getmp3list {nick uhost channel handle rest args} {
global mp3list

 if {![isthere $nick "$mp3list(download)"]} {return 0}
 mp3out $nick "I am sending you the mp3list."
 dccsend "${mp3list(download)}" $nick
 #dccsend "${directory}${filename}" $nick
 putlog "-=- !$nick! from ![maskhost $uhost]! got $mp3list(download) -=-"
}

proc isthere {nick fname} {
 if {![file exists $fname]} {mp3out $nick "Can't find $fname"; return 0}
 return 1
}


##### MP3LIST ########################################################
bind dcc - mp3list dcc_mp3list
proc dcc_mp3list {handle idx rest} {
 pub_mp3listsearch $idx * $handle $idx $rest
                                   }

bind pub - [cmdchar]mp3list pub_mp3listsearch
proc pub_mp3listsearch {nick uhost handle chan args} {
  global mp3list urlfile prefix totfound mp3list
  if {[lindex $args 0] != ""} {

 set a [lindex $args 0]
 set b [lindex $a 0]
 set c [lrange $a 1 end]
 foreach ab $c {
  append b "*"
  append b $ab
               }

  domp3search $nick $b $mp3list(list)
  } else {
    mp3out $nick "Syntax: [cmdchar]mp3list <search string>"
  }
  return 1
}


bind msg - mp3list msg_mp3listsearch
proc msg_mp3listsearch {nick uhost handle args} {
  global urlfile prefix botnick totfound mp3list
  if {[lindex $args 0] != ""} {
 set a [lindex $args 0]
 set b [lindex $a 0]
 set c [lrange $a 1 end]
 foreach ab $c {
 append b "*"
 append b $ab
 }
  domp3search $nick $b $mp3list(list)
  } else {
    mp3out $nick "Syntax: /msg $botnick mp3list <search string>"
  }
  return 1
}


proc domp3search {nick data sdb} {
global mp3list
    mp3out $nick "MP3List Search $mp3list(ver) by DrN"
    mp3out $nick "Searching Database for \"$data\""
    if {$mp3list(maxsearch) != 0} {mp3out $nick "There is a limit of $mp3list(maxsearch) results in effect."}
    set data [string tolower $data]

#foreach sdb $mp3list(lists) {

 set sdbf [lindex $sdb 0]
 set sdbd [lrange $sdb 1 end]
 mp3out $nick "Searching $sdbd"
 searchmp3list $nick $sdbf $data
#                        }


}

proc searchmp3list {nick database data} {
 global mp3list info
    set in [open $database r]
    set totfound 0
    set linenum 0

    while {![eof $in]} {
      set line [gets $in]
      set p [string first "|" $line];
      set dir [string range $line 0 [expr $p - 1]]
      set fname [string range $line [expr $p + 1] [string length $line]]
      incr linenum 1
      if {[string match "*$data*" [string tolower $fname]]} {
       parse_mp3 "$line"
       mp3out $nick "#$linenum: $info(2)"
       

      if {$totfound > $mp3list(maxsearch)} {
                  mp3out $nick "There are over $mp3list(maxsearch) matches. Please norrow your search."
                  mp3out $nick "Use \002[cmdchar]mp3info #\002 to retrieve information on found songs."
                  mp3out $nick "Use \002[cmdchar]mp3request #\002 to request a song."
                  mp3out $nick "Type [cmdchar]getmp3list  to retrieve the full list."
                  close $in
                  return 0
                                   }
        set totfound [expr $totfound + 1]
     }
    }
    close $in
    mp3out $nick "There was a total of $totfound out of $linenum entries matching your query."
    mp3out $nick "Use \002[cmdchar]mp3info #\002 to retrieve information on found songs."
    mp3out $nick "Use \002[cmdchar]mp3request #\002 to request a song."
    mp3out $nick "Type [cmdchar]getmp3list  to retrieve the full list."
}

bind dcc - mp3info dcc_mp3info
proc dcc_mp3info {handle idx rest} {
 pub_mp3info $idx * $handle $idx $rest
                                   }

bind pub - [cmdchar]mp3info pub_mp3info
proc pub_mp3info {nick uhost handle chan args} {
  global mp3list
 domp3info $nick $handle $args $mp3list(list)
}

proc domp3info {nick hand data sdb} {
global mp3list
 set sdbf [lindex $sdb 0]
 set sdbd [lrange $sdb 1 end]
 mp3out $nick "MP3List Search $mp3list(ver) by DrN"
 mp3out $nick "Retrieving info for #$data"
 set data [string tolower $data]

 mp3out $nick "Searching in $sdbd"
 infomp3list $nick $hand $sdbf $data
}

proc infomp3list {nick hand database data} {
 global mp3list info
    set in [open $database r]
    set totfound 0
    set linenum 0

    while {![eof $in]} {
      set line [gets $in]

      incr linenum 1
      if {$linenum == $data} {

       parse_mp3 "$line"
#1:dir 2:file 3:TITLE 4:ARTIST 5:ALBUM 6:YEAR 7:COMMENT 8:GENRE


        mp3out $nick "#\002$linenum\002: \026Filename:\026 $info(2)"
        mp3out $nick "\026Songname:\026 [format "%-30s" $info(3)] \026 Year :\026 $info(6)"
        mp3out $nick "\026Artist  :\026 [format "%-30s" $info(4)] \026Genre :\026 $info(8)"
        mp3out $nick "\026Album   :\026 $info(5)"
        mp3out $nick "\026Info    :\026 $info(7)"
      if {[matchattr $hand m]} {mp3out $nick "\026Path    :\026 $info(1)/"}
      if {$linenum == $data} {close $in; return 0}
        set totfound [expr $totfound + 1]
     }
    }
    close $in

}

proc parse_mp3 {line} {
global info
set info(1) "boing"; unset info
set marker 1; set info(1) ""
for {set p 0} {$p < [string length $line]} {incr p} {
 set ap 1
 set ch [string index $line $p]
 if {$ch == "|"} {set marker [expr $marker + 1]; set ap 0;set info($marker) ""} 
 if {$ap == 1} {append info($marker) $ch
#                set $info($marker) "$info($marker)$ch"
               }
                                                    }
for {set p 3} {$p < 9} {incr p} {if {$info($p)==""} {set info($p) "Unknown"}}

}

proc getinfomp3list {database data} {
 global mp3list
    set in [open $database r]
    set totfound 0
    set linenum 0

    while {![eof $in]} {
      set line [gets $in]
      incr linenum 1
      if {$linenum == $data} {close $in; return "$line"}
      set totfound [expr $totfound + 1]
                       }
    close $in
 return ""
}

proc getmp3listfilename {database data} {
 global mp3list info
    set in [open $database r]
    set totfound 0
    set linenum 0

    while {![eof $in]} {
      set line [gets $in]
      incr linenum 1
      if {$linenum == $data} {
                              close $in; 
                              parse_mp3 "$line"
                              return "$info(2)"}
      set totfound [expr $totfound + 1]
                       }
    close $in
 return ""
}
  
proc mp3out {target text} {
if {[isnum $target]} {putidx $target "$text"; return 0}
if {[string index $target 0]=="#"} {puthelp "PRIVMSG $target :$text"
                                   } else {puthelp "NOTICE $target :$text"}
}

# isnumber taken from alltools.tcl
proc isnum {string} {
  if {([string compare $string ""]) && (![regexp \[^0-9\] $string])} then {return 1}
  return 0
}

##### MP3REQUEST #####################################################
bind msg - mp3request msg_mp3request
proc msg_mp3request {nick uhost handle args} {
 domp3request $nick $uhost $handle $nick $args
}

bind pub - [cmdchar]mp3request pub_mp3request
proc pub_mp3request {nick uhost handle chan args} {
  global mp3list
 domp3request $nick $handle $args $mp3list(list)
}

proc domp3request {nick handle args sdb} {
 global mp3list mp3requests

 if {$args == ""} {mp3out $nick "Calling Syntax: mp3request song#"; return 0}

 set sdbf [lindex $sdb 0]
 set sdbd [lrange $sdb 1 end]

 set fname [getmp3listfilename $sdbf $args]
 if {$fname==""} {putmp3 $nick "#$args is an invalid request."; return 0}
 if {$mp3requests(0)==0} {
                          set mp3requests(0) [expr $mp3requests(0) + 1]
                          set mp3requests($mp3requests(0)) "$nick $args $fname"
                          mp3out $nick "Request for #$args - $fname recorded."
                          return 0
                         }
 set p 0
 set f 0
 while {$p < $mp3requests(0)} {
  set p [expr $p + 1]
  if {[string tolower $nick] == [string tolower [lindex $mp3requests($p) 0]]} {set f 1}
                              }
 if {$f == 1} {mp3out $nick "You allready have a request waiting."; return 0}  
 set mp3requests(0) [expr $mp3requests(0) + 1]
 set mp3requests($mp3requests(0)) "$nick $args $fname" 
 mp3out $nick "Request for #$args - $fname recorded."
}

bind dcc - mp3del dcc_mp3del
proc dcc_mp3del {handle idx rest} {
# pub_mp3info $idx * $handle $idx $rest
global mp3requests info mp3list
 if {$rest == ""} {mp3out $idx "Calling Syntax: mp3del #"; return 0}
 if {$mp3requests(0)==0} {mp3out $idx "Sorry, there's currentlly no requests."; return 0}
 if {($rest < 0) || ($rest > $mp3requests(0))} {mp3out $idx "Invalid number given."; return 0}

 set del $mp3requests($rest)
 set p $rest
 while {$p < $mp3requests(0)} {
  set p1 [expr $p + 1]
  set mp3requests($p) $mp3requests($p1)
  set p [expr $p + 1]
                              }
  set mp3requests(0) [expr $mp3requests(0) - 1]
  mp3out $idx "Request #$rest removed."
  
  set fname [getinfomp3list [lindex $mp3list(list) 0] [lindex $del 1]]
  parse_mp3 "$fname"
  if {[matchattr $handle m]} {mp3out $idx "\026FullPath:\026 $info(1)/$info(2)"}

}

bind dcc - mp3requests dcc_mp3requests
proc dcc_mp3requests {handle idx rest} {
# pub_mp3info $idx * $handle $idx $rest
global mp3requests
 set p 0
 if {$mp3requests(0)==0} {mp3out $idx "Sorry, there's currentlly no requests."; return 0}
 mp3out $idx "### Nick     Song# File Name"
 mp3out $idx "--- -------- ----- -----------------------------------------"
 while {$p < $mp3requests(0)} {
  set p [expr $p + 1]
  set b [lindex $mp3requests($p) 0]
  set n [lindex $mp3requests($p) 1]
  set f [lrange $mp3requests($p) 2 end]
  mp3out $idx "[format "%-3s" $p] [format "%-8s" $b] [format "%-5s" $n] $f"
                                   }
}

putlog "MP3List $mp3list(ver) by David Proper (DrN) -: LoadeD :-"
return "MP3List $mp3list(ver) by David Proper (DrN) -: LoadeD :-"

